<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.7" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="indexpage" kind="group">
    <compoundname>index</compoundname>
    <title>Over The Air v2.0.0 Overview</title>
    <detaileddescription>
<para>This library provides support for OTA updating using WiFi of the application code running on a PSoC 6 MCU with CYW4343W or CYW43012 connectivity device. For simplification, this document will refer to an MQTT Broker or an HTTP Server as "server".</para><para>The library provides a number of combinations on how to get the OTA Image. One or two steps can be used to get the OTA Image. The two steps are "get job" and "get data". The caller can skip the "get job" step and get the OTA Image directly.</para><para>Step 1 - Get Job:<linebreak />
<itemizedlist>
<listitem><para>The OTA Agent downloads a JSON "job" document (default name "ota_update.json").<linebreak />
</para></listitem><listitem><para>The Job document has information about an update that is available, including location.</para></listitem></itemizedlist>
</para><para>Step 2: - Get Data:<linebreak />
<itemizedlist>
<listitem><para>The OTA Agent will download the OTA Image to the Secondary Slot (slot 1).<linebreak />
 On the next reboot, MCUBoot will copy the new version of the application from the Secondary Slot (slot 1) to the Primary slot (slot 0) and run the application.</para></listitem></itemizedlist>
</para><para>The user can skip Step 1 by setting the field use_get_job_flow in <ref kindref="compound" refid="structcy__ota__network__params__t">cy_ota_network_params_t</ref> to CY_OTA_DIRECT_FLOW when calling <ref kindref="member" refid="group__group__ota__functions_1ga84d744546862b858ddc65334be5b63c3">cy_ota_agent_start()</ref>.</para><para>The ModusToolbox OTA code examples import this library automatically.</para>
<para><heading level="1">Features and functionality</heading></para>
<para>This library utilizes MQTT or HTTPS and TLS to securely connect to and download an update for the users application.</para><para>Other features:</para><para><itemizedlist>
<listitem><para>Configuration to adjust multiple timing values to customize how often to check for updates, and other parameters for the MQTT Broker connection.</para></listitem><listitem><para>Runs in a separate background thread, only connecting to the server based on the parameters passed to <ref kindref="member" refid="group__group__ota__functions_1ga84d744546862b858ddc65334be5b63c3">cy_ota_agent_start()</ref>.</para></listitem><listitem><para>Server info, credentials, and other parameters are passed into <ref kindref="member" refid="group__group__ota__functions_1ga84d744546862b858ddc65334be5b63c3">cy_ota_agent_start()</ref>.</para></listitem><listitem><para>Provides a callback mechanism to report stages of connect, download percentage, and errors.</para></listitem></itemizedlist>
</para><para>Once the application starts the OTA agent, the OTA agent will contact the server at the defined intervals to see if there is an update available.</para>

<para><heading level="1">Integration notes</heading></para>
<para>A pre-defined configuration file has been bundled with this library.<linebreak />
 The user is expected to:<linebreak />
<itemizedlist>
<listitem><para>Copy the cy_ota_config.h file from the libs/anycloud-ota/configs<linebreak />
 directory to the top-level code example directory.<linebreak />
<linebreak />
</para></listitem><listitem><para>Add the following to COMPONENTS in the code example project's Makefile<linebreak />
<itemizedlist>
<listitem><para>FREERTOS, PSOC6HAL, LWIP, MBEDTLS and either 4343W or 43012 depending on the platform.<linebreak />
 For instance, if CY8CKIT-062]S2-43012 is chosen, then the Makefile entry would be:<linebreak />
<programlisting><codeline><highlight class="normal">COMPONENTS=FREERTOS<sp />PSOC6HAL<sp />LWIP<sp />MBEDTLS<sp />43012</highlight></codeline>
</programlisting></para></listitem></itemizedlist>
</para></listitem></itemizedlist>
</para>

<para><heading level="1">General Concept</heading></para>
<para>The OTA Agent stores the update to the Secondary Slot and uses MCUBoot to validate and copy the update from the Secondary Slot to the Primary Slot.<linebreak />
<itemizedlist>
<listitem><para>MCUBoot runs the current application in Primary Slot.<linebreak />
</para></listitem><listitem><para>The OTA Agent downloads the update and stores it in the Secondary Slot.<linebreak />
</para></listitem><listitem><para>The Secondary Slot is marked so that MCUBoot will copy it over to the Primary Slot.<linebreak />
</para></listitem><listitem><para>If validate_after_reboot == 0 then Secondary Slot will be tagged as "perm"<linebreak />
</para></listitem><listitem><para>If validate_after_reboot == 1 then Secondary Slot will be tagged as "test"<linebreak />
</para></listitem><listitem><para>If reboot_upon_completion == 1, the system will reboot automatically.<linebreak />
</para></listitem><listitem><para>On the next system reboot, MCUBoot sees that there is an update in the Secondary Slot and copies the update to the Primary Slot.<linebreak />
</para></listitem><listitem><para>MCUBoot runs the current application (now the update) in Primary Slot.<linebreak />
</para></listitem><listitem><para>If validate_after_reboot == 1 then the updated application must validate itself and call <ref kindref="member" refid="group__group__ota__functions_1gaedc8ac983fc4781d0a4ca3e5dc113ec5">cy_ota_validated()</ref> to inform MCUBoot that it is now "perm" to complete the process.</para></listitem></itemizedlist>
</para>

<para><heading level="1">API Overview</heading></para>
<para><heading level="2">Start The OTA Agent </heading>
</para><para>cy_ota_start_agent() is a non-blocking call, which returns a context pointer that is used in subsequent calls.<linebreak />
 The OTA Agent uses callbacks to signal application when events occur.<linebreak />
 <linebreak />
 cy_rslt_t <ref kindref="member" refid="group__group__ota__functions_1ga84d744546862b858ddc65334be5b63c3">cy_ota_agent_start(cy_ota_network_params_t *network_params, cy_ota_agent_params_t *agent_params, cy_ota_context_ptr *ota_ptr)</ref>;</para><para>These defines determine when the checks happen. Between checks, the OTA Agent is not conencted to a server, and not checking for updates.<linebreak />
<itemizedlist>
<listitem><para>CY_OTA_INITIAL_CHECK_SECS</para></listitem><listitem><para>CY_OTA_NEXT_CHECK_INTERVAL_SECS</para></listitem><listitem><para>CY_OTA_RETRY_INTERVAL_SECS</para></listitem><listitem><para>CY_OTA_CHECK_TIME_SECS</para></listitem></itemizedlist>
</para><para><heading level="2">Stop OTA agent </heading>
</para><para>When you want to stop the OTA agent from checking for updates.<linebreak />
 <linebreak />
 cy_rslt_t <ref kindref="member" refid="group__group__ota__functions_1ga14b8129ff45b6af3bd71235676a220be">cy_ota_agent_stop(cy_ota_context_ptr *ota_ptr)</ref>;</para><para><heading level="2">Trigger a check right now. </heading>
</para><para>Use this when you want to trigger a check for an OTA update earlier than<linebreak />
 is currently scheduled. The OTA agent must have been started already.<linebreak />
 <linebreak />
 cy_rslt_t <ref kindref="member" refid="group__group__ota__functions_1ga749e2780daeb68e40d47ca8c90a6922c">cy_ota_get_update_now(cy_ota_context_ptr ota_ptr)</ref>;</para>

<para><heading level="1">Override default settings</heading></para>
<para>Copy the cy_ota_config.h file from the libs/anycloud-ota/configs<linebreak />
 directory to the top-level code example directory in the project.<linebreak />
 Change these values to your preferred settings.</para><para><programlisting><codeline />
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_INITIAL_CHECK_SECS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(10)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />10<sp />seconds<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_NEXT_CHECK_INTERVAL_SECS<sp /><sp /><sp /><sp /><sp />(24<sp />*<sp />60<sp />*<sp />60)<sp /><sp /></highlight><highlight class="comment">/*<sp />1<sp />day<sp />between<sp />checks<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_RETRY_INTERVAL_SECS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(5)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />5<sp />seconds<sp />between<sp />retries<sp />after<sp />an<sp />error<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_CHECK_TIME_SECS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(10<sp />*<sp />60)<sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />10<sp />minutes<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_PACKET_INTERVAL_SECS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(0)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />default<sp />disabled<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_JOB_CHECK_TIME_SECS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(30)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />30<sp />seconds<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_DATA_CHECK_TIME_SECS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(5<sp />*<sp />60)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />5<sp />minutes<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_RETRIES<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(3)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />retry<sp />entire<sp />process<sp />3<sp />times<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_CONNECT_RETRIES<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(3)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />3<sp />server<sp />connect<sp />retries<sp /><sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_MAX_DOWNLOAD_TRIES<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(3)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />3<sp />download<sp />OTA<sp />Image<sp />retries<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/**********************************************************************</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />Message<sp />Defines</highlight></codeline>
<codeline><highlight class="comment"><sp />**********************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />PUBLISHER_LISTEN_TOPIC<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"publish_notify"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />COMPANY_TOPIC_PREPEND<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"anycloud"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />PUBLISHER_DIRECT_TOPIC<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"OTAImage"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_RESULT_SUCCESS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"Success"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_RESULT_FAILURE<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"Failure"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_SUBSCRIBE_UPDATES_AVAIL<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">"{\</highlight></codeline>
<codeline><highlight class="preprocessor">\"Message\":\"Update<sp />Availability\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"Manufacturer\":<sp />\"Express<sp />Widgits<sp />Corporation\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"ManufacturerID\":<sp />\"EWCO\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"ProductID\":<sp />\"Easy<sp />Widgit\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"SerialNumber\":<sp />\"ABC213450001\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"BoardName\":<sp />\"CY8CPROTO_062_4343W\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"Version\":<sp />\"%d.%d.%d\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"UniqueTopicName\":<sp />\"%s\"\</highlight></codeline>
<codeline><highlight class="preprocessor">}"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_DOWNLOAD_REQUEST<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">"{\</highlight></codeline>
<codeline><highlight class="preprocessor">\"Message\":\"Request<sp />Update\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"Manufacturer\":<sp />\"Express<sp />Widgits<sp />Corporation\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"ManufacturerID\":<sp />\"EWCO\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"ProductID\":<sp />\"Easy<sp />Widgit\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"SerialNumber\":<sp />\"ABC213450001\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"BoardName\":<sp />\"CY8CPROTO_062_4343W\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"Version\":<sp />\"%d.%d.%d\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"UniqueTopicName\":<sp />\"%s\"\</highlight></codeline>
<codeline><highlight class="preprocessor">}"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_DOWNLOAD_DIRECT_REQUEST<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">"{\</highlight></codeline>
<codeline><highlight class="preprocessor">\"Message\":\"Send<sp />Direct<sp />Update\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"Manufacturer\":<sp />\"Express<sp />Widgits<sp />Corporation\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"ManufacturerID\":<sp />\"EWCO\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"ProductID\":<sp />\"Easy<sp />Widgit\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"SerialNumber\":<sp />\"ABC213450001\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"BoardName\":<sp />\"CY8CPROTO_062_4343W\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"Version\":<sp />\"%d.%d.%d\"<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">}"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_MQTT_RESULT_JSON<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">"{\</highlight></codeline>
<codeline><highlight class="preprocessor">\"Message\":\"%s\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"UniqueTopicName\":<sp />\"%s\"\</highlight></codeline>
<codeline><highlight class="preprocessor">}"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_HTTP_RESULT_JSON<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">"{\</highlight></codeline>
<codeline><highlight class="preprocessor">\"Message\":\"%s\",<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">\"File\":\"%s\"<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor">}"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#ifndef<sp />CY_OTA_HTTP_GET_TEMPLATE</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_OTA_HTTP_GET_TEMPLATE<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor"><sp /><sp /><sp /><sp />"GET<sp />%s<sp />HTTP/1.1\r\n"<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor"><sp /><sp /><sp /><sp />"Host:<sp />%s:%d<sp />\r\n"<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor"><sp /><sp /><sp /><sp />"\r\n"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#ifndef<sp />CY_OTA_HTTP_POST_TEMPLATE</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_OTA_HTTP_POST_TEMPLATE<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor"><sp /><sp /><sp /><sp />"POST<sp />%s<sp />HTTP/1.1\r\n"<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor"><sp /><sp /><sp /><sp />"Content-Length:%ld<sp />\r\n"<sp />\</highlight></codeline>
<codeline><highlight class="preprocessor"><sp /><sp /><sp /><sp />"\r\n%s"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/**********************************************************************</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />MQTT<sp />Defines</highlight></codeline>
<codeline><highlight class="comment"><sp />**********************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_MQTT_KEEP_ALIVE_SECONDS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(60)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />60<sp />second<sp />keep-alive<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_MQTT_MAX_TOPICS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(2)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_MQTT_TOPIC_PREFIX<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"cy_ota_device"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="preprocessor">#define<sp />CY_OTA_MQTT_CLIENT_ID_PREFIX<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"cy_device"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting></para>

<para><heading level="1">Code Snippets</heading></para>
<para><linebreak />
 The following code snip demonstrates an example for initializing the <ref kindref="compound" refid="structcy__ota__network__params__t">cy_ota_network_params_t</ref> and ota_agent_params structures required to start the OTA agent.<linebreak />
 <programlisting><codeline><highlight class="comment">/*<sp />Macro<sp />to<sp />enable/disable<sp />TLS<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />ENABLE_TLS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(false)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Number<sp />of<sp />MQTT<sp />topic<sp />filters<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MQTT_TOPIC_FILTER_NUM<sp /><sp /><sp />(1)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />MQTT<sp />topics<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />*<sp />mqtt_topics[<sp />MQTT_TOPIC_FILTER_NUM<sp />]<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="stringliteral">"anycloud/test/ota/image"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Root<sp />CA<sp />Certificate<sp />-</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp />Must<sp />include<sp />the<sp />PEM<sp />header<sp />and<sp />footer:</highlight></codeline>
<codeline><highlight class="comment" /></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"-----BEGIN<sp />CERTIFICATE-----\n"<sp />\</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />".........base64<sp />data.......\n"<sp />\</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"-----END<sp />CERTIFICATE-------\n"</highlight></codeline>
<codeline><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />ROOT_CA_CERTIFICATE<sp /><sp /><sp /><sp /><sp />""</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Client<sp />Certificate</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp />Must<sp />include<sp />the<sp />PEM<sp />header<sp />and<sp />footer:</highlight></codeline>
<codeline><highlight class="comment" /></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"-----BEGIN<sp />CERTIFICATE-----\n"<sp />\</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />".........base64<sp />data.......\n"<sp />\</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"-----END<sp />CERTIFICATE-------\n"</highlight></codeline>
<codeline><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />CLIENT_CERTIFICATE<sp /><sp /><sp /><sp /><sp /><sp />""</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Private<sp />Key</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp />Must<sp />include<sp />the<sp />PEM<sp />header<sp />and<sp />footer:</highlight></codeline>
<codeline><highlight class="comment" /></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"-----BEGIN<sp />RSA<sp />PRIVATE<sp />KEY-----\n"<sp />\</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"...........base64<sp />data.........\n"<sp />\</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"-----END<sp />RSA<sp />PRIVATE<sp />KEY-------\n"</highlight></codeline>
<codeline><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />CLIENT_KEY<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />""</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />OTA<sp />context<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ga50b8b1ec191a1d5f9a8fcd3472811694">cy_ota_context_ptr</ref><sp />ota_context;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />ota_callback(<ref kindref="member" refid="group__group__ota__typedefs_1gad852fa8cdb0431df709ccf12bb37cd60">cy_ota_cb_reason_t</ref><sp />reason,<sp />uint32_t<sp />value,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*cb_arg<sp />);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />MQTT<sp />Credentials<sp />for<sp />OTA<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">struct<sp /></highlight><highlight class="normal">IotNetworkCredentials<sp />tls_credentials<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.pRootCa<sp />=<sp />ROOT_CA_CERTIFICATE,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.rootCaSize<sp />=<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(ROOT_CA_CERTIFICATE),</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.pClientCert<sp />=<sp />CLIENT_CERTIFICATE,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.clientCertSize<sp />=<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(CLIENT_CERTIFICATE),</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.pPrivateKey<sp />=<sp />CLIENT_KEY,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.privateKeySize<sp />=<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(CLIENT_KEY),</highlight></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Network<sp />parameters<sp />for<sp />OTA<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__ota__network__params__t">cy_ota_network_params_t</ref><sp />ota_network_params<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp />.connection<sp />=<sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggabc03646427dec963bef37cb5dbb550faa7955097dd62d0b81cb447d287d12bd98">CY_OTA_CONNECTION_MQTT</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp />.mqtt<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp />.awsIotMqttMode<sp />=<sp />0,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />This<sp />parameter<sp />must<sp />be<sp />1<sp />when<sp />using<sp />the<sp />AWS<sp />IoT<sp />MQTT<sp />server,<sp />0<sp />otherwise<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp />.pIdentifier<sp />=<sp /></highlight><highlight class="stringliteral">"CY_IOT_DEVICE"</highlight><highlight class="normal">,<sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />MQTT<sp />identifier<sp />-<sp />less<sp />than<sp />17<sp />characters<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp />.pTopicFilters<sp />=<sp />mqtt_topics,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp />.numTopicFilters<sp />=<sp />MQTT_TOPIC_FILTER_NUM,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp />.broker<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.pHostName<sp />=<sp /></highlight><highlight class="stringliteral">"test.mosquitto.org"</highlight><highlight class="normal">,<sp /><sp /></highlight><highlight class="comment">/*<sp />MQTT<sp />Broker<sp />endpoint<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#if<sp />(ENABLE_TLS<sp />==<sp />true)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.port<sp />=<sp />8884<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />MQTT<sp />Server<sp />Port<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.port<sp />=<sp />1883</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp />},</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#if<sp />(ENABLE_TLS<sp />==<sp />true)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp />.credentials<sp />=<sp />&amp;tls_credentials</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp />.credentials<sp />=<sp />NULL</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp />},</highlight></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Parameters<sp />for<sp />OTA<sp />agent<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__ota__agent__params__t">cy_ota_agent_params_t</ref><sp />ota_agent_params<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcy__ota__agent__params__t_1a2f3b68d908f64e031aca84d871554850">cb_func</ref><sp />=<sp />ota_callback,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />value<sp />to<sp />NULL<sp />if<sp />callback<sp />function<sp />is<sp />not<sp />used<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.cb_arg<sp />=<sp />&amp;ota_context,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />value<sp />to<sp />NULL<sp />if<sp />callback<sp />function<sp />is<sp />not<sp />used<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.reboot_upon_completion<sp />=<sp />1</highlight></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting> <linebreak />
 The example function demonstrates the usage of OTA callback function to print the status of every OTA event. The callback feature is optional but be aware that the OTA middleware will not print the status of the OTA agent on its own.<linebreak />
 <linebreak />
 Note: User needs to initialize retarget-io to use the debug UART port.<linebreak />
 <programlisting><codeline><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />Function<sp />Name:<sp />ota_callback()</highlight></codeline>
<codeline><highlight class="comment"><sp />*******************************************************************************</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />Summary:</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp /><sp />Got<sp />a<sp />callback<sp />from<sp />OTA</highlight></codeline>
<codeline><highlight class="comment"><sp />*</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp /><sp />@param[in][out]<sp />cb_data<sp />-<sp />structure<sp />holding<sp />information<sp />for<sp />the<sp />Application</highlight></codeline>
<codeline><highlight class="comment"><sp />*</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />Return:</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp /><sp />CY_OTA_CB_RSLT_OTA_CONTINUE<sp />-<sp />OTA<sp />Agent<sp />to<sp />continue<sp />with<sp />function,<sp />using<sp />modified<sp />data<sp />from<sp />Application</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp /><sp />CY_OTA_CB_RSLT_OTA_STOP<sp /><sp /><sp /><sp /><sp />-<sp />OTA<sp />Agent<sp />to<sp />End<sp />current<sp />update<sp />session<sp />(do<sp />not<sp />quit).</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp /><sp />CY_OTA_CB_RSLT_APP_SUCCESS<sp /><sp />-<sp />Application<sp />completed<sp />task,<sp />OTA<sp />Agent<sp />use<sp />success</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp /><sp />CY_OTA_CB_RSLT_APP_FAILED<sp /><sp /><sp />-<sp />Application<sp />completed<sp />task,<sp />OTA<sp />Agent<sp />use<sp />failure</highlight></codeline>
<codeline><highlight class="comment"><sp />*</highlight></codeline>
<codeline><highlight class="comment"><sp />*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ga83280df2ca46db528cc12901d949fd63">cy_ota_callback_results_t</ref><sp />ota_callback(<ref kindref="compound" refid="structcy__ota__cb__struct__t">cy_ota_cb_struct_t</ref><sp />*cb_data)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ga83280df2ca46db528cc12901d949fd63">cy_ota_callback_results_t</ref><sp /><sp /><sp />cb_result<sp />=<sp /><ref kindref="member" refid="group__group__ota__typedefs_1gga83280df2ca46db528cc12901d949fd63a9b6b16fa9fcb36760749ced06ea21513">CY_OTA_CB_RSLT_OTA_CONTINUE</ref>;<sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />OTA<sp />Agent<sp />to<sp />continue<sp />as<sp />normal<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*state_string;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*error_string;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ga50b8b1ec191a1d5f9a8fcd3472811694">cy_ota_context_ptr</ref><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />ctx<sp />=<sp />NULL;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(cb_data<sp />==<sp />NULL)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1gga83280df2ca46db528cc12901d949fd63ab33edc4fae91e1c99f93933fc3a06bd5">CY_OTA_CB_RSLT_OTA_STOP</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />ctx<sp />=<sp />*((<ref kindref="member" refid="group__group__ota__typedefs_1ga50b8b1ec191a1d5f9a8fcd3472811694">cy_ota_context_ptr</ref><sp />*)cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1afa47e10a9fe4712558dded6625a3c484">cb_arg</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(ctx<sp />==<sp />NULL)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1gga83280df2ca46db528cc12901d949fd63ab33edc4fae91e1c99f93933fc3a06bd5">CY_OTA_CB_RSLT_OTA_STOP</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />state_string<sp />=<sp /><ref kindref="member" refid="group__group__ota__functions_1gafcd8ac0ada4557076da8070d11101f95">cy_ota_get_state_string</ref>(cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a48361e091a9b49cc103b9b37d7328784">state</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />error_string<sp />=<sp /><ref kindref="member" refid="group__group__ota__functions_1gaffc74d5bb4dd74ede1031222b9efcd9b">cy_ota_get_error_string</ref>(<ref kindref="member" refid="group__group__ota__functions_1ga7149423078fe0b9d401bddc1d0e808d1">cy_ota_get_last_error</ref>());</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">switch</highlight><highlight class="normal"><sp />(cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1ae28ffd179023e8902cbd3e88785540ad">reason</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggad852fa8cdb0431df709ccf12bb37cd60a6f1fe12d222a4fcb6aef59d045cc40af">CY_OTA_LAST_REASON</ref>:<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />to<sp />keep<sp />linker<sp />happy<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggad852fa8cdb0431df709ccf12bb37cd60a98710a7a1d2678890cda211ab2c89689">CY_OTA_REASON_SUCCESS</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />SUCCESS<sp />state:%d<sp />%s<sp />last_error:%s\n"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a48361e091a9b49cc103b9b37d7328784">state</ref>,<sp />state_string,<sp />error_string);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggad852fa8cdb0431df709ccf12bb37cd60ad2bf02c326de5c6c95551123155e14bd">CY_OTA_REASON_FAILURE</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />FAILURE<sp />state:%d<sp />%s<sp />last_error:%s\n"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a48361e091a9b49cc103b9b37d7328784">state</ref>,<sp />state_string,<sp />error_string);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggad852fa8cdb0431df709ccf12bb37cd60a7d2f0693d44fd480e23c7de3c2f68d10">CY_OTA_REASON_STATE_CHANGE</ref>:</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">switch</highlight><highlight class="normal"><sp />(cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a48361e091a9b49cc103b9b37d7328784">state</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />informational<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fae28d1cd8c5a985bb343a0828c234fdd0">CY_OTA_STATE_NOT_INITIALIZED</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fab4dff9b84c5eafa48e4d3eaff2302ba5">CY_OTA_STATE_EXITING</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fa4980922c9b3cf3c4e1269324d4563d78">CY_OTA_STATE_INITIALIZING</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375faa1a4033af52d14af2873066da8f89098">CY_OTA_STATE_AGENT_STARTED</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375faf2dbf8dcfb8d9329549fa539970d9e54">CY_OTA_STATE_AGENT_WAITING</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />STATE<sp />CHANGE<sp />state:%d<sp />%s<sp />last_error:%s\n"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a48361e091a9b49cc103b9b37d7328784">state</ref>,<sp />state_string,<sp />error_string);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fad8e99bc84c807fa17f23b119900d4c1a">CY_OTA_STATE_START_UPDATE</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />STATE<sp />CHANGE<sp />CY_OTA_STATE_START_UPDATE\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fa4b481536d237fc9672cff019e5a24392">CY_OTA_STATE_STORAGE_OPEN</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />STORAGE<sp />OPEN\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375faf8b6a7adfb042c0b4379db005eb03fcb">CY_OTA_STATE_STORAGE_WRITE</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />STORAGE<sp />WRITE<sp />%ld%%<sp />(%ld<sp />of<sp />%ld)\n"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a1d802b856542ce6b7e59e2559026307d">percentage</ref>,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1ab43108a89dadf59dcad71d4b4c75411d">bytes_written</ref>,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1ad29859423d69a8e0815a833a70284bdb">total_size</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fa8177ec48fc37847b69d33f90a3b4333b">CY_OTA_STATE_STORAGE_CLOSE</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />STORAGE<sp />CLOSE\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fafdf0e2e6deb544bc5bdc5dec53b0609f">CY_OTA_STATE_JOB_CONNECT</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />CONNECT<sp />FOR<sp />JOB<sp />using<sp />"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />NOTE:</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp /><sp />MQTT<sp />-<sp />json_doc<sp />holds<sp />the<sp />MQTT<sp />JSON<sp />request<sp />doc</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp /><sp />HTTP<sp />-<sp />json_doc<sp />holds<sp />the<sp />HTTP<sp />"GET"<sp />request</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1aabc069ca938caaeda44300df68d31903">connection_type</ref><sp />==<sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggabc03646427dec963bef37cb5dbb550faa7955097dd62d0b81cb447d287d12bd98">CY_OTA_CONNECTION_MQTT</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"MQTT:<sp />server:%s<sp />port:<sp />%d\n"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a0c9a21c445dda18f419957d7612ea497">broker_server</ref>.<ref kindref="member" refid="structcy__ota__server__info__t_1a0a79919e0a3bb279b462942fb410cb5b">pHostName</ref>,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a0c9a21c445dda18f419957d7612ea497">broker_server</ref>.<ref kindref="member" refid="structcy__ota__server__info__t_1a824fa715a00ad3c161b7a8cde090914d">port</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"HTTP:<sp />server:%s<sp />port:<sp />%d\n"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a0c9a21c445dda18f419957d7612ea497">broker_server</ref>.<ref kindref="member" refid="structcy__ota__server__info__t_1a0a79919e0a3bb279b462942fb410cb5b">pHostName</ref>,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a0c9a21c445dda18f419957d7612ea497">broker_server</ref>.<ref kindref="member" refid="structcy__ota__server__info__t_1a824fa715a00ad3c161b7a8cde090914d">port</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fa53922a893f09e01688b27c5d225e27a5">CY_OTA_STATE_JOB_DOWNLOAD</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />JOB<sp />DOWNLOAD<sp />using<sp />"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />NOTE:</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp /><sp />MQTT<sp />-<sp />json_doc<sp />holds<sp />the<sp />MQTT<sp />JSON<sp />request<sp />doc</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp /><sp />HTTP<sp />-<sp />json_doc<sp />holds<sp />the<sp />HTTP<sp />"GET"<sp />request</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1aabc069ca938caaeda44300df68d31903">connection_type</ref><sp />==<sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggabc03646427dec963bef37cb5dbb550faa7955097dd62d0b81cb447d287d12bd98">CY_OTA_CONNECTION_MQTT</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"MQTT:<sp />'%s'"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a2b43a418b275e5ef22173df42f4b9efa">json_doc</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />topic:<sp />'%s'<sp />\n"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1ab3b3a87b636c188c6549c614a50ba4e3">unique_topic</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"HTTP:<sp />'%s'"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a71bfd9cf787fc18dfd42b54950103a25">file</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fa5f9288e902dc5473fd3e681eb2c43012">CY_OTA_STATE_JOB_DISCONNECT</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />JOB<sp />DISCONNECT\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fa1a5597cb918e3a60890c003ca2b35926">CY_OTA_STATE_JOB_PARSE</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />PARSE<sp />JOB:<sp />'%.*s'<sp />\n"</highlight><highlight class="normal">,<sp />strlen(cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a2b43a418b275e5ef22173df42f4b9efa">json_doc</ref>),<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a2b43a418b275e5ef22173df42f4b9efa">json_doc</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fa7d1ad039e8599533b1bd50c4068a41da">CY_OTA_STATE_JOB_REDIRECT</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />JOB<sp />REDIRECT\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fab8c745b4b9dd7c582c1cc6735ad1401e">CY_OTA_STATE_DATA_CONNECT</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />CONNECT<sp />FOR<sp />DATA<sp />using<sp />"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1aabc069ca938caaeda44300df68d31903">connection_type</ref><sp />==<sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggabc03646427dec963bef37cb5dbb550faa7955097dd62d0b81cb447d287d12bd98">CY_OTA_CONNECTION_MQTT</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"MQTT:<sp />%s:%d<sp />\n"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a0c9a21c445dda18f419957d7612ea497">broker_server</ref>.<ref kindref="member" refid="structcy__ota__server__info__t_1a0a79919e0a3bb279b462942fb410cb5b">pHostName</ref>,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a0c9a21c445dda18f419957d7612ea497">broker_server</ref>.<ref kindref="member" refid="structcy__ota__server__info__t_1a824fa715a00ad3c161b7a8cde090914d">port</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"HTTP:<sp />%s:%d<sp />\n"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a0c9a21c445dda18f419957d7612ea497">broker_server</ref>.<ref kindref="member" refid="structcy__ota__server__info__t_1a0a79919e0a3bb279b462942fb410cb5b">pHostName</ref>,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a0c9a21c445dda18f419957d7612ea497">broker_server</ref>.<ref kindref="member" refid="structcy__ota__server__info__t_1a824fa715a00ad3c161b7a8cde090914d">port</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fa2821523d7c323f672da8b19b45d5d935">CY_OTA_STATE_DATA_DOWNLOAD</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />DATA<sp />DOWNLOAD<sp />using<sp />"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />NOTE:</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp /><sp />MQTT<sp />-<sp />json_doc<sp />holds<sp />the<sp />MQTT<sp />JSON<sp />request<sp />doc</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp /><sp />HTTP<sp />-<sp />json_doc<sp />holds<sp />the<sp />HTTP<sp />"GET"<sp />request</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1aabc069ca938caaeda44300df68d31903">connection_type</ref><sp />==<sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggabc03646427dec963bef37cb5dbb550faa7955097dd62d0b81cb447d287d12bd98">CY_OTA_CONNECTION_MQTT</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"MQTT:<sp />'%s'<sp />\n"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a2b43a418b275e5ef22173df42f4b9efa">json_doc</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />topic:<sp />'%s'<sp />\n"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1ab3b3a87b636c188c6549c614a50ba4e3">unique_topic</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"HTTP:<sp />'%s'<sp />\n"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a2b43a418b275e5ef22173df42f4b9efa">json_doc</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />file:<sp />'%s'<sp />\n"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a71bfd9cf787fc18dfd42b54950103a25">file</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fa1957660855d0051d85c9c6bc52bee808">CY_OTA_STATE_DATA_DISCONNECT</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />DATA<sp />DISCONNECT\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fa64f1d70db6ac1c7b6053aa72a829cfd7">CY_OTA_STATE_VERIFY</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />VERIFY\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fa155daa564765a5efdb0f5e647832c25b">CY_OTA_STATE_RESULT_REDIRECT</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />RESULT<sp />REDIRECT\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fa32bb3fbef7ed0e85e1130a8f8c206ac2">CY_OTA_STATE_RESULT_CONNECT</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />SEND<sp />RESULT<sp />CONNECT<sp />using<sp />"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />NOTE:</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp /><sp />MQTT<sp />-<sp />json_doc<sp />holds<sp />the<sp />MQTT<sp />JSON<sp />request<sp />doc</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp /><sp />HTTP<sp />-<sp />json_doc<sp />holds<sp />the<sp />HTTP<sp />"GET"<sp />request</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1aabc069ca938caaeda44300df68d31903">connection_type</ref><sp />==<sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggabc03646427dec963bef37cb5dbb550faa7955097dd62d0b81cb447d287d12bd98">CY_OTA_CONNECTION_MQTT</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"MQTT:<sp />Broker:%s<sp />port:<sp />%d\n"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a0c9a21c445dda18f419957d7612ea497">broker_server</ref>.<ref kindref="member" refid="structcy__ota__server__info__t_1a0a79919e0a3bb279b462942fb410cb5b">pHostName</ref>,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a0c9a21c445dda18f419957d7612ea497">broker_server</ref>.<ref kindref="member" refid="structcy__ota__server__info__t_1a824fa715a00ad3c161b7a8cde090914d">port</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />topic:<sp />'%s'<sp />\n"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1ab3b3a87b636c188c6549c614a50ba4e3">unique_topic</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"HTTP:<sp />Server:%s<sp />port:<sp />%d\n"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a0c9a21c445dda18f419957d7612ea497">broker_server</ref>.<ref kindref="member" refid="structcy__ota__server__info__t_1a0a79919e0a3bb279b462942fb410cb5b">pHostName</ref>,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a0c9a21c445dda18f419957d7612ea497">broker_server</ref>.<ref kindref="member" refid="structcy__ota__server__info__t_1a824fa715a00ad3c161b7a8cde090914d">port</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fa38c70df41f2fab401d96e10bc21cb395">CY_OTA_STATE_RESULT_SEND</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />SENDING<sp />RESULT<sp />using<sp />"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />NOTE:</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp /><sp />MQTT<sp />-<sp />json_doc<sp />holds<sp />the<sp />MQTT<sp />JSON<sp />request<sp />doc</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp /><sp />HTTP<sp />-<sp />json_doc<sp />holds<sp />the<sp />HTTP<sp />"PUT"</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1aabc069ca938caaeda44300df68d31903">connection_type</ref><sp />==<sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggabc03646427dec963bef37cb5dbb550faa7955097dd62d0b81cb447d287d12bd98">CY_OTA_CONNECTION_MQTT</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"MQTT:<sp />'%s'<sp />\n"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a2b43a418b275e5ef22173df42f4b9efa">json_doc</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"HTTP:<sp />'%s'<sp />\n"</highlight><highlight class="normal">,<sp />cb_data-&gt;<ref kindref="member" refid="structcy__ota__cb__struct__t_1a2b43a418b275e5ef22173df42f4b9efa">json_doc</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fa559e81062c0a2f47f03dcbffefbc7a75">CY_OTA_STATE_RESULT_RESPONSE</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />Got<sp />Result<sp />response\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fa7608a11942fc4b42c3487335639fd719">CY_OTA_STATE_RESULT_DISCONNECT</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />Result<sp />Disconnect\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375fa1a0a36230c7f92d5b5af2394e14fa6a1">CY_OTA_STATE_OTA_COMPLETE</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"APP<sp />CB<sp />OTA<sp />Session<sp />Complete\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ota__typedefs_1ggab1539ebc23219f1ca64318286e9d375faabbd5e53bc741afd226adfd143dde572">CY_OTA_NUM_STATES</ref>:<sp /></highlight><highlight class="comment">/*<sp />to<sp />keep<sp />compiler<sp />happy<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />switch<sp />state<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />cb_result;</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting> <linebreak />
 The following code snip demonstrates the initialization of OTA agent.<linebreak />
 <programlisting><codeline><highlight class="comment">/*<sp />Initialze<sp />and<sp />start<sp />OTA<sp />agent<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />ota_setup(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*****************************************************************************</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />&lt;<sp />Add<sp />code<sp />snippet<sp />here<sp />to<sp />initialze<sp />and<sp />connect<sp />to<sp />a<sp />Wi-Fi<sp />AP<sp />&gt;</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />underlying<sp />support<sp />code<sp />that<sp />is<sp />needed<sp />for<sp />OTA<sp />and<sp />MQTT<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotSdk_Init();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Call<sp />the<sp />Network<sp />Secured<sp />Sockets<sp />initialization<sp />function.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotNetworkSecureSockets_Init();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />MQTT<sp />subsystem<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />IotMqtt_Init();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Add<sp />the<sp />network<sp />interface<sp />to<sp />the<sp />OTA<sp />network<sp />parameters<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />ota_network_params.<ref kindref="member" refid="structcy__ota__network__params__t_1abf5643e6336accb1b9bb7e5b219f3553">network_interface</ref><sp />=<sp />(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*)IOT_NETWORK_INTERFACE_CY_SECURE_SOCKETS;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />and<sp />start<sp />the<sp />OTA<sp />agent<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ota__functions_1ga84d744546862b858ddc65334be5b63c3">cy_ota_agent_start</ref>(&amp;ota_network_params,<sp />&amp;ota_agent_params,<sp />&amp;ota_context);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> <linebreak />
</para>

<para><heading level="1">Code Example</heading></para>
<para>For AnyCloud OTA v1.2.0 code example, please refer to this example:<linebreak />
 <ulink url="https://github.com/cypresssemiconductorco/mtb-example-anycloud-ota-mqtt">https://github.com/cypresssemiconductorco/mtb-example-anycloud-ota-mqtt</ulink><linebreak />
 <linebreak />
</para>
    </detaileddescription>
  </compounddef>
</doxygen>